/********************************************************************************************************/
/*
 Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#ifndef ACQUISITION_H
#define ACQUISITION_H
//
/*************************************************************************/
//
// Librairies OpenCV
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
#endif  // endif
// Inclusion des librairies
#include <stdio.h>
#include <QMutex>
#include "Analyzer.h"
#include "Controller.h"
#include "../Zor/Tools.h"
#include "../Zor/Device.h"
//
/*************************************************************************/
//
namespace AAC {
//
class Acquisition : public QThread {
	//
	Q_OBJECT
	//
public:
    //
	Acquisition();
	~Acquisition();
	//
	void run();
	//
	void setState(Zor::Tools::ETAT_WEBCAM etat);
	//
private:
    //
    Zor::Device * _Device;
    Analyzer * _Analyzer;
    Controller * _Controller;
	Zor::Tools::ETAT_WEBCAM _WebcamState;      // Variable ou l'on stocke l'etat de la webcam
	QMutex _MutexState;
	QMutex * _MutexAnalyzer;
    //
}; // Acquisition
//
} // AAC
//
#endif // ACQUISITION_H
//
/*************************************************************************/


