/********************************************************************************************************/
/*
 Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#ifndef ANALYZER_H
#define ANALYZER_H
//
/*************************************************************************/
//
// Librairies OpenCV
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
#endif  // endif
// Inclusion des librairies
#include <stdio.h>
#include <iostream>
#include "../GC/Tools.h"
#include <QMutex>
#include <QThread>
#include <QDesktopWidget>
#include <QObject>
#include <QPoint>
#include <QVector>
#include <QPointF>
//
/*************************************************************************/
//
namespace AAC {
//
class Analyzer : public QObject {
	//
	Q_OBJECT
	//
public:
    //
	Analyzer();
	~Analyzer();
	//
	void loop_analyze();
	int getPoints();
	void setPoints(QVector<CvPoint> &liste);
	void analyze(IplImage* image);
	void update(const QPoint& point);
    QPointF getDistanceXY() { return _DistanceXY; }
    QVector<double> getRayonC() { return _RayonC; }
    inline QVector<CvPoint> getListePoints() { return _ListePointsAttente; }
	//
private:
    //
    void calculDistanceXY(QVector<QPoint> point);
    void calculRayonC(QVector<QPoint> point);
    //
    QPoint _ResolutionEcran;
    QPoint _ResolutionWebcam;
    QPointF _Tolerance;
    QPointF _Decalage;
    QPointF _Coefficient;
	QVector<QPoint>  _Seuil;
    QVector<double> _RayonC;
    QPointF _DistanceXY;
    //
	QMutex _MutexState;
    QVector<CvPoint> _ListePoints;
    QVector<CvPoint> _ListePointsAttente;



    //
}; // Analyser
//
} // AAC
//
#endif // ANALYZER_H
//
/*************************************************************************/

