/********************************************************************************************************/
/*
 Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier FrÈdÈric (University of Science and Technology of Nantes)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 Contact: glovecontrol@free.fr
 */
/********************************************************************************************************/
//
#ifndef EVENTS_H
#define EVENTS_H
//
// Librairies OpenCV et EvÈnement systËme
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
//#include <CoreServices/CoreServices.h>
#include <ApplicationServices/ApplicationServices.h>
#endif
//
// Librairies STL
#include<cmath>
//
namespace AAC {
namespace EE {
//
class Events {
public:
    //
	virtual ~Events();
	//
    static int clickDroitDown(const CvPoint& pt);
    //
    static int clickDroitUp(const CvPoint& pt);
    //
    static int clickGaucheDown(const CvPoint& pt);
    //
    static int clickGaucheUp(const CvPoint& pt);
    //
    static int doubleClick(const CvPoint& pt);
    //
    static int deplaceCurseurPt(const CvPoint& ptdest);
    //
    static int glisseCurseurGauchePt(const CvPoint& ptdest);
    //
    static int glisseCurseurDroitPt(const CvPoint& ptdest);
    //
};
} // EE
} // AAC
#endif // EVENTS_H
//
/********************************************************************************************************/

