/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#ifndef GCTRAY_H
#define GCTRAY_H
//
// Librairies QT
#include <QWidget>
#include <QtGui>
#include <QSystemTrayIcon>
#include <QMessageBox>
#include <QAction>
#include <QMenu>
#include <QIcon>
#include <QFile>
// Librairies UI
#include "../UI/UIZor.h"
// Librairies AAC
#include "../AAC/Acquisition.h"
// Librairies Zor
#include "../Zor/Tools.h"
#include "../AAC/Analyzer.h"
//
namespace GC {
//
class Tray : public QSystemTrayIcon {
    //
	Q_OBJECT
	//
public:
    //
	Tray();
	~Tray();
	//
	void start();
    inline QAction * getRunStopAction() { return runstopAction; }
    //
private slots:
    //
    void startstop();
    void calibrate();
    void help();
    void iconActivated(QSystemTrayIcon::ActivationReason reason);
    void terminateCalibrate();
    //
private:
    //
    void initVariables();
    void createActions();
    void createMenuIcon();
    //
	QAction * runstopAction;
    QAction * calibrateAction;
    QAction * helpAction;
    QAction * quitAction;
    QMenu * trayMenu;
    //
    UIZor * calibrateWindow;
    //
    bool running;
    //
    AAC::Acquisition * acquisition;

};
//
}   // GC
//
#endif // GCTRAY_H
//
/********************************************************************************************************/
