/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
/*
Cette classe formalise les diffrentes tapes ncessaires au calibrage. Elle met en relation les diffrentes
classes. Et elle permet l'affichage de l'interface graphique
*/
//
#ifndef UIZor_H
#define UIZor_H
//
// Librairies QT
#include <QtGui/QWidget>
#include <QDir>
#include <QString>
#include <QFileDialog>
#include <QMessageBox>
#include <QFile>
#include <QTextStream>
#include <QCoreApplication>
// Librairies Zor
#include "../Zor/Display.h"
#include "../Zor/Seuil.h"
#include "../Zor/Webcam.h"
#include "../Zor/Tools.h"
#include "../Zor/DisplayCouleurs.h"
#include "../Zor/DisplayMouvement.h"
#include "ui_UIZor.h"
// Librairies Autres
#include <iostream>
//
class UIZor : public QWidget, public Ui::UIZor
{
	Q_OBJECT
	//
public:
    //
	UIZor( QWidget* = 0 );
	~UIZor();
    //

protected:
    //
    void closeEvent(QCloseEvent *event);
    //
public slots:
    //

    void existe(bool);                  // Les zones slectionnes par l'utilisateur existent
    void etapeChoix();                  // Choix entre le calibrage de mouvement et des couleurs
    // Les diffrentes tapes de calibration
    // Couleurs
    void etape11();
    void etape12();
    void etape13();
    void etape14();
    void etape15();
    // Mouvements
    void etape21();
    void etape22();
    void etape23();
    //
signals:
	//
	void updateText(const QString& );   // Mise  jour des fps
	void terminate();                   // Terminaison du calibrage
	//
private:
    //
    void start();                       // Lancement des tapes de calibrage (initialisation)
    bool sauvegarde1();                 // Sauvegarde du seuil pour les couleurs
    bool sauvegarde2();                 // Sauvegarde des 3 points pour le mouvement
    //
    Zor::Webcam * _Webcam;                      // Priphrique permettant de rcuprer les images de la webcam
    Zor::DisplayCouleurs * _DisplayCouleurs;    // Calibrage des couleurs
    Zor::DisplayMouvement * _DisplayMouvement;  // Calibrage du mouvement
    Zor::Seuil * _Seuil;                        // Algorithme gntique


};
//
#endif // UIZor_H
//
/********************************************************************************************************/
