/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#include "Device.h"
//
namespace Zor{
//
/*************************************************************************************************************/
// Constructeur de la classe (initialisation des variables)
Device::Device() {
    width = 0.0;
    height = 0.0;
	currentTime = new QTime();
}
//
/*************************************************************************************************************/
// Destructeur de la classe
Device::~Device() {
	if(currentTime) delete(currentTime);
	if(capture) cvReleaseCapture(&capture);
}
//
/*************************************************************************************************************/
// Lancement de la capture
void Device::start(IplImage * iplimage) {
	capture = cvCreateCameraCapture(0);     // Recuperation et Ouverture du flux video de la webcam
    iplimage = cvQueryFrame(capture);       // Extraction d'une frame pour obtenir la resolution de la webcam

	width = iplimage->width;     // Recuperation de la largeur
	height = iplimage->height;   // Recuperation de la hauteur
	_State=true;

	currentTime->start();
	lastFPS = -1;
	currentFPS = 0;
}
//
/*************************************************************************************************************/
// Arrt de la capture
void Device::stop() {
    cvReleaseCapture(&capture);             // Relachement du controleur de la camera
    _State=false;
}
//
/*************************************************************************************************************/
// Mise  jour des fps
void Device::update() {
	if(lastFPS!=currentTime->elapsed()/1000)
	  {
		lastFPS=currentTime->elapsed()/1000;
		FPS=currentFPS;
		currentFPS=0;
	  }
	currentFPS++;
}
//
/*************************************************************************************************************/
// Rcuprer les fps
QString Device::getQStringFPS() {
	return _QString.setNum(FPS,10);
}
//
/*************************************************************************************************************/
// Rcuprer les fps
int Device::getFPS() {
	return FPS;
}
//
/*************************************************************************************************************/
// Rcuprer la rsolution
QString Device::getQStringResolution() {
    QString buffer_1,buffer_2;
    buffer_1.setNum(width,'f',0);
    buffer_2.setNum(height,'f',0);
    return buffer_1+" x "+buffer_2;

}
//
/*************************************************************************************************************/
// Rcuprer la rsolution
QPoint Device::getResolution(){
    return QPoint((int)width, (int)height);
}
//
/*************************************************************************************************************/
//
}   // Zor
//
/*************************************************************************/
//

