/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#ifndef Webcam_H
#define Webcam_H
//
// Librairies QT
#include <QtGui/QWidget>
#include <QThread>
#include <QMutex>
#include <QEvent>
#include <QDesktopWidget>
#include <QLabel>
#include <QPainter.h>
// Librairies OpenCV
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
#endif  // endif
// Librairies
#include <stdio.h>
#include "Tools.h"
#include "Device.h"
#include "Display.h"
#include "DisplayCouleurs.h"
//
namespace Zor {
//
class Webcam : public QThread {
    //
	Q_OBJECT
	//
public:
    //
	Webcam( Display * display = 0);
	~Webcam();
	//
    void run();
    void setDisplay( Display * display );
    //inline ETAT_WEBCAM getEtatWebcam() { return etatWebcam; }
    void setEtatWebcam(Zor::Tools::ETAT_WEBCAM etat);
	Device * getDevice(){ return _Device; }
    //
public slots:
    //
    void changeState();
    //
signals:
    //
    void updateFPS(const QString& chaine);
    void updateResolution(const QString& chaine);
	void updateLog(const QString& chaine);
    //
private:
    //
    Zor::Tools::ETAT_WEBCAM _WebcamState;      // Variable ou l'on stocke l'etat de la webcam
    Device * _Device;                          // Peripherique de controle pour recuperer les FPS
    Display * _Display;                        // Fenetre ou sera affich l'image
    QMutex _MutexState;
};
//
}   // Zor
//
#endif // Webcam_H
//
/********************************************************************************************************/
